/*
 *
 * Copyright (C) 2003 Sadysta ( http://sadysta.ath.cx )
 * Copyright (C) 2007 Tomasz Ostrowski ( http://ostry.w.szu.pl ) - modified from 1.8.9 source
 *
 * This file is part of Free GG.
 *
 * Free GG is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Free GG is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Free GG; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

//---------------------------------------------------------------------------

#ifndef HistoryH
#define HistoryH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ImgList.hpp>
#include <ToolWin.hpp>
#include <FileCtrl.hpp>
//---------------------------------------------------------------------------
class TPreviewThread: public TThread
{
private:
        void __fastcall Execute();
public:
        __fastcall TPreviewThread(bool CreateSuspended);
        void __fastcall Update();

        TListItem *I;
        AnsiString FileName;
        int count, p;
        bool rtf;
};
//---------------------------------------------------------------------------
class THistoryForm : public TForm
{
__published:	// IDE-managed Components
        TButton *Button1;
        TPanel *Panel1;
        TTreeView *TreeView1;
        TSplitter *Splitter1;
        TImageList *ImageList1;
        TPanel *Panel2;
        TListView *ListView1;
        TSplitter *Splitter2;
        TRichEdit *RichEdit1;
        TCoolBar *CoolBar1;
        TToolBar *ToolBar1;
        TToolButton *ToolButton1;
        TImageList *ImageList2;
        TToolButton *ToolButton2;
        TToolButton *ToolButton3;
        TStatusBar *StatusBar1;
        TToolButton *ToolButton4;
        TPanel *Panel3;
        TLabel *Label1;
        TEdit *Edit1;
        TLabel *Label2;
        TRadioButton *r1;
        TRadioButton *r2;
        void __fastcall FormShow(TObject *Sender);
        void __fastcall TreeView1Change(TObject *Sender, TTreeNode *Node);
        void __fastcall ListView1Change(TObject *Sender, TListItem *Item,
          TItemChange Change);
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall ToolButton2Click(TObject *Sender);
        void __fastcall ToolButton3Click(TObject *Sender);
        void __fastcall ListView1KeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
        void __fastcall StatusBar1DrawPanel(TStatusBar *StatusBar,
          TStatusPanel *Panel, const TRect &Rect);
        void __fastcall Button1Click(TObject *Sender);
        void __fastcall ToolButton1Click(TObject *Sender);
        void __fastcall Edit1KeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
private:	// User declarations
	bool bEnableNextSearch;	///< zezwl na kolejne uruchomienie wtku przeszukiwania archiwum
public:		// User declarations
        __fastcall THistoryForm(TComponent* Owner);
        void __fastcall MyWndProc (Messages::TMessage &Msg);
        void PrepareList();
		void __fastcall EnableNextSearch(TObject *Sender);
		AnsiString GenPreview (AnsiString FileName, INT count, BOOL rtf);
        AnsiString log_file;
        TWndMethod old;
        TTreeNode *LogTop, *SMSTop;

        TPreviewThread *PT;
};
//---------------------------------------------------------------------------
extern PACKAGE THistoryForm *HistoryForm;
//---------------------------------------------------------------------------
#endif
